Qore::TransformInputStream Class Reference

This class implements the InputStream interface for reading bytes from another InputStream while applying a transformation. More...

Inheritance diagram for Qore::TransformInputStream:
[legend]

## Public Member Functions

| constructor (Qore::InputStream is, Qore::Transform t)
| Creates the TransformInputStream. More...
int | peek ()
| Peeks the next byte available from the input stream; returns -1 if no more data available. More...
*binary | read (int limit)
| Reads bytes (up to a specified limit) from the input stream; returns NOTHING if there are no more bytes in the stream. More...
Public Member Functions inherited from Qore::InputStream
| constructor ()
| Constructor. More...

## Detailed Description

This class implements the InputStream interface for reading bytes from another InputStream while applying a transformation.

Note
  stream classes are not designed to be accessed from multiple threads; they have been implemented without locking for fast and efficient use when used from a single thread. For methods that would be unsafe to use in another thread, any use of such methods in threads other than the thread where the constructor was called will cause a `STREAM-THREAD-ERROR` to be thrown.

See also
  StreamReader for a class that can be used to read various kinds of data from an InputStream

Since
  Qore 0.8.13

## Member Function Documentation

## constructor()

Qore::TransformInputStream::constructor | ( | Qore::InputStream | is,
|  | Qore::Transform | t
| ) |  |

Creates the TransformInputStream.

Parameters

  is | the underlying InputStream where the data to transform will be read from
  t | the transformation to apply

## peek()

int Qore::TransformInputStream::peek | ( |  | ) |

virtual

Peeks the next byte available from the input stream; returns -1 if no more data available.

Returns
  the next byte available from the input stream or -1 if no more data is available

Example:
  int nextByte = transformStream.peek();

Exceptions

  STREAM-THREAD-ERROR | this exception is thrown if this method is called from any thread other than the thread that created the object

Implements Qore::InputStream.

## read()

*binary Qore::TransformInputStream::read | ( | int | limit | ) |

virtual

Reads bytes (up to a specified limit) from the input stream; returns NOTHING if there are no more bytes in the stream.

Parameters

  limit | the maximum number of bytes to read

Returns
  the read bytes (the length is between 1 and `limit` inclusive) or NOTHING if no more bytes are available

Exceptions

  INPUT-STREAM-ERROR | limit is not positive
  STREAM-THREAD-ERROR | this exception is thrown if this method is called from any thread other than the thread that created the object

Implements Qore::InputStream.